var path, pathTools;

path = require('path');

module.exports = pathTools = {
  compare: function(a, b) {
    var a2Ancestor, aComps, ancestor2A, ancestor2B, ancestorPath, b2Ancestor, bComps, i, part, ret, _i, _j, _k, _len, _ref, _ref1, _ref2, _ref3;
    aComps = this._getComponents(a);
    bComps = this._getComponents(b);
    ancestorPath = [];
    a2Ancestor = [];
    b2Ancestor = [];
    ancestor2A = [];
    ancestor2B = [];
    for (i = _i = 0, _len = aComps.length; _i < _len; i = ++_i) {
      part = aComps[i];
      if (part !== bComps[i]) {
        break;
      }
      ancestorPath.push(part);
    }
    for (i = _j = _ref = ancestorPath.length, _ref1 = aComps.length - 1; _ref <= _ref1 ? _j <= _ref1 : _j >= _ref1; i = _ref <= _ref1 ? ++_j : --_j) {
      if (i < aComps.length - 1) {
        a2Ancestor.push('..');
      }
      ancestor2A.push(aComps[i]);
    }
    for (i = _k = _ref2 = ancestorPath.length, _ref3 = bComps.length - 1; _ref2 <= _ref3 ? _k <= _ref3 : _k >= _ref3; i = _ref2 <= _ref3 ? ++_k : --_k) {
      if (i < bComps.length - 1) {
        b2Ancestor.push('..');
      }
      ancestor2B.push(bComps[i]);
    }
    return ret = {
      commonAncestor: this._fromArray(ancestorPath),
      a2Ancestor: this._fromArray(a2Ancestor),
      b2Ancestor: this._fromArray(b2Ancestor),
      ancestor2A: this._fromArray(ancestor2A),
      ancestor2B: this._fromArray(ancestor2B)
    };
  },
  _getComponents: function(p) {
    return p = p.split('\\').join('/').split('/');
  },
  _getCommonAncestor: function(a, b) {
    var i, part, soFar, _i, _len;
    soFar = [];
    for (i = _i = 0, _len = a.length; _i < _len; i = ++_i) {
      part = a[i];
      if (part === b[i]) {
        soFar.push(part);
      } else {
        break;
      }
    }
    return soFar;
  },
  _fromArray: function(a) {
    return a.join('/');
  },
  slashesOnly: function(p) {
    return p.split('\\').join('/');
  },
  replaceExtension: function(file, newExt) {
    var ext;
    ext = path.extname(file);
    return file.substr(0, file.length - ext.length) + '.' + newExt;
  }
};
